<?php

use Illuminate\Database\Migrations\Migration;
use Illuminate\Database\Schema\Blueprint;
use Illuminate\Support\Facades\Schema;

return new class extends Migration
{
    /**
     * Run the migrations.
     *
     * @return void
     */
    public function up()
    {
        Schema::create('claims', function (Blueprint $table) {
            $table->id();
            $table->uuid('uuid');
            $table->string('code')->index();
            $table->foreignId('claim_request_id')->nullable()->index();
            $table->foreignId('member_id')->index();
            // $table->foreignId('diagnosis_id')->index()->nullable();
            $table->string('currency');
            $table->string('total_claim')->nullable();
            $table->foreignId('plan_id')->index()->nullable();
            $table->foreignId('benefit_id')->index()->nullable();

            $table->string('status');

            // $table->dateTime('requested_at')->nullable();
            // $table->unsignedBigInteger('requested_by')->nullable()->index();

            // $table->dateTime('received_at')->nullable();
            // $table->unsignedBigInteger('received_by')->nullable()->index();

            // $table->dateTime('approved_at')->nullable();
            // $table->unsignedBigInteger('approved_by')->nullable()->index();

            // $table->dateTime('declined')->nullable();
            // $table->unsignedBigInteger('declined_by')->nullable()->index();

            // $table->dateTime('paid_at')->nullable();
            // $table->unsignedBigInteger('paid_by')->nullable()->index();

            $table->timestamps();
            $table->softDeletes();
            $table->unsignedBigInteger('created_by')->nullable()->index();
            $table->unsignedBigInteger('updated_by')->nullable()->index();
            $table->unsignedBigInteger('deleted_by')->nullable()->index();
        });
    }

    /**
     * Reverse the migrations.
     *
     * @return void
     */
    public function down()
    {
        Schema::dropIfExists('claims');
    }
};
